// 4 Dec 2006 : Coding by Simone Mannori
//              ScicosHIL porting under Windows
//              First working code :) 
//
// 7 Dec 2006 : Final 1.0 version 

/* Include files */

#include <windows.h>                    /* Compiler's include files's */
#include <string.h>

#include <stdlib.h>
#include <stdio.h>

#include "scicos_block.h"  /* Specific for scicos block developement */
#include "machine.h"

#include "cbw.h"           /* Specific for MC USB devices  */ 
 
#define Init           4   /* Initialization */ 
#define OutputUpdate   1
#define StateUpdate    2
#define Integration    0
#define Mode           9    /* Zero Crossing */
#define EventScheduler 3
#define Ending         5   

/*ULAI01.C****************************************************************
File:                         ULAI01.C
Library Call Demonstrated:    cbAIn()
Purpose:                      Reads an A/D Input Channel.
Demonstration:                Displays the analog input on a
                              user-specified channel until a
                              key is pressed.
Other Library Calls:          cbErrHandling()
Special Requirements:         Board 0 must have an A/D converter.
                              Analog signal on an input channel.
                              CB.CFG must be in the current directory.
***************************************************************************/
  


 //** static structure inside block->work  
  typedef struct {    
	/* Variable Declarations */
    int BoardNum ;
    int UDStat   ;
    int Chan     ;
    int range    ; //** 0-7 range selection progressive id (as Comedi)
    int Gain     ; //** symbolic id
  } McUsbAnIn    ;


void diff_analog_input(scicos_block *block, int flag) 
{
  McUsbAnIn *AIdata ; //** define the local datastructure 
  
  WORD DataValue = 0;
  float    EngUnits;
  float    RevLevel = (float)CURRENTREVNUM;

  double y[1]     ;
      
  switch(flag) {  
      
      case Init: //** Card and port init
         *block->work = (McUsbAnIn *) scicos_malloc(sizeof(McUsbAnIn));
         if (*block->work  == NULL ) 
           { //** in case of error exit 
	         set_block_error(-16); return; //** --> Exit point  
           }
         //** else ..... 
		 AIdata = (McUsbAnIn *) *block->work; //** map the local structure in the scicos_block user data  
         
		 AIdata->Chan  = block->ipar[0] ; // channel selection  
         AIdata->range = block->ipar[1] ; // range selection
     
         AIdata->BoardNum = 0 ; // the first board of  CB.CFG  
     
         AIdata->Gain = BIP20VOLTS;
	     switch( AIdata->range) {
	       case 0: 
		         AIdata->Gain = BIP20VOLTS;
	           break ;
		   case 1:
	             AIdata->Gain = BIP10VOLTS;
	           break ;
		   case 2:
                 AIdata->Gain = BIP5VOLTS;
		       break ;  
		   case 3:
	             AIdata->Gain = BIP4VOLTS;
		       break ;  
		   case 4:
	             AIdata->Gain = BIP2PT5VOLTS;
               break ;
		   case 5:
	             AIdata->Gain = BIP2VOLTS;
               break ;
		   case 6:
	             AIdata->Gain = BIP1PT25VOLTS;
               break ;
		   case 7:
	             AIdata->Gain = BIP1VOLTS;
               break ;
	     }

		 /* Declare UL Revision Level */
         AIdata->UDStat = cbDeclareRevision(&RevLevel);

         /* Initiate error handling
         Parameters:
            PRINTALL :all warnings and errors encountered will be printed
            DONTSTOP :program will continue even if error occurs.
                      Note that STOPALL and STOPFATAL are only effective in 
                      Windows applications, not Console applications. 
         */
          cbErrHandling (PRINTALL, DONTSTOP);
	     
		 // Commented out because is too time comsuming for the Init of many blocks
         //AIdata->UDStat = cbFlashLED (AIdata->BoardNum); //** Blink the greeen led ;) 

     break; 
     //**------------------------------------------------------------------------------------

     case OutputUpdate:
      AIdata = (McUsbAnIn *) *block->work;
	        
	  	  
        /*Parameters:
            BoardNum    :number used by CB.CFG to describe this board
            Chan        :input channel number
            Gain        :gain for the board in BoardNum
            DataValue   :value collected from Chan */

        AIdata->UDStat = cbAIn (AIdata->BoardNum, AIdata->Chan, AIdata->Gain, &DataValue);
        AIdata->UDStat = cbToEngUnits (AIdata->BoardNum, AIdata->Gain, DataValue, &EngUnits);

        printf ("%6u ...", DataValue);
        printf ("   %.2f \n", EngUnits);
	    y[0] = EngUnits;
	  
	    block->outptr[0][0] = y[0];
      break;
      
      case Ending:
          AIdata = (McUsbAnIn *) *block->work;
      //** :)
      break;	  
        
  } // close the switch
   
} // close the function 

